/* 
	csw-tabs-vertical.js
   
   Version: [2018-01-02 01:28 pm]
*/
var vTabHash = window.location.hash; 


jQuery(document).ready(function() {

	// setup On Click Handlers
	jQuery('.cswTabsVert nav > ul > li > a').click( function(event){ doTabsVertClick(event, jQuery(this)); } );
	jQuery('.cswTabsVert a.tabAccordionHeader').click( function(event){ doTabsVertAccordionClick(event, jQuery(this)); } );	


	// If URL parameter 'activeTab' is defined, use that as the hash
	var aTab = getURLParam('activeTab');
   if( typeof aTab == 'undefined' )
      aTab = getURLParam('activetab');
   if( typeof aTab == 'undefined' )
      aTab = getURLParam('ActiveTab');
      

	if( typeof aTab != 'undefined' && aTab != '' )
		vTabHash = aTab;	 
   
   // Process if a anchor/bookmark hash is passed if via URL
	if ( typeof vTabHash != 'undefined' && vTabHash != '' )
   {
      jQuery('a.cswTabVertAnchor').each(function(i,v){
		
			var id = jQuery(v).attr('id');
			var id = id.replace('hTabID-', '');
			
			if( id.toLowerCase() == vTabHash.toLowerCase() )
				jQuery(v).click();
      });
   }
   
});

function doTabsVertClick(event, el)
{
	var e = jQuery(el);
	var clickedLI = e.parent();
	var clickedHREF = e.attr('href');
	
	var ul = clickedLI.parent();
	var activeLI = ul.find('[class*="tab-current"]');
	var activeA = activeLI.children(':first');
	var activeHREF = activeA.attr('href');

	// remove tab-current class from active tab and add to newly clicked tab
	activeLI.removeClass('tab-current');
	clickedLI.addClass('tab-current');

	// remove tab-current class from active content and add to newly clicked content
	if( typeof activeHREF != 'undefined' )
		jQuery(activeHREF).removeClass('content-current');
	
	if( typeof clickedHREF != 'undefined' )
		jQuery(clickedHREF).addClass('content-current');
	
	event.preventDefault();	
}

function doTabsVertAccordionClick(event, el)
{
	var e = jQuery(el);
	var clickedHREF = e.attr('href');
	var aWrapper = e.parent();							// aWrapper
	var clickedSection = aWrapper.parent();		// section tag
	var contentWrap = clickedSection.parent();	// div cswContentWrap
	var tabContainers = contentWrap.parent();		// div cswTabContainers
	var tabs = tabContainers.parent();				// div tabs
	var widgetID = tabs.parent().attr('id');
	var elementID = widgetID.replace('cswTabs-', '');
	
	var activeSection = contentWrap.find('[class*="content-current"]');
	var activeA = activeSection.children(':first');
	var activeHREF = activeA.attr('href');

	// remove content-current class from active tab and add to newly clicked tab
	activeSection.removeClass('content-current');
	clickedSection.addClass('content-current');
	
	// Remove tab-current class from active tab

	var activeLI = tabs.find('[class*="tab-current"]');
	if( typeof activeLI != 'undefined' )
		jQuery(activeLI).removeClass('tab-current');

	// Add tab-current class to clicked tab
	activeA = tabs.find('[href*="' + clickedHREF + '"]');
	parentLI = activeA.parent();
	if( typeof parentLI != 'undefined' )
		jQuery(parentLI).addClass('tab-current');

	// scroll the clicked accordion header into view, if it is not already in view
	if( typeof window['cswTabs_' + elementID + '_ScrollOffset'] != 'undefined' && window['cswTabs_' + elementID + '_ScrollOffset'] >= 0 )	
	{
		var scroll = window['cswTabs_' + elementID + '_ScrollOffset'];
		setTimeout( function(){ scrollTabsVertical(el, scroll ); }, 200 );
	}	
	event.preventDefault();	
	event.stopPropagation();
}

// Scroll to top of selected accordion
// - to make sure tab content is showing on a mobile device
function scrollTabsVertical(element, accordionScrollOffset) 
{
	var e = jQuery(element);	// a tag clicked
  	var eOffset = e.offset();
	var section = e.parent().parent();
	var sOffset = section.offset();
	var sHeight = section.outerHeight();
	
	// get Current Scroll Pos
	var curPos = $(document).scrollTop();
	var wH = $(window).height();

	if( eOffset.top > curPos + accordionScrollOffset 
			&& sOffset.top + sHeight < curPos + accordionScrollOffset + wH )
	{
		// the entire section is visible, do nothing
		return;
	} 
	
	jQuery('html,body').animate( { scrollTop: eOffset.top - accordionScrollOffset }, 500);
}


/****

//
// Open Vertical Tabs from URL hash (looks for an element with id of 'vTabID-{hash}"
//
function openRelatedVerticalTab(hashList) {
	var i = 0;
	var listArr = hashList.split(':');

	for (i = 0; i < listArr.length; ++i)
	{
		// remove hash ##
		var hash = listArr[i];
		var id = 'vTabID-' + hash.replace('#', '').toLowerCase();

		// check if tab with that ID exists
		if( jQuery('#' + id).length )
			jQuery('#' + id)[0].click();
	}
   
   return; 
}

//
// Open Accordion Panel from URL hash (looks for panel element with id of 'vPanelID-{hash}"
// 
function openRelatedAccordionPanel(hashList) {
	var i = 0;
   var hashList = hashList.replace('#', '');
	var listArr = hashList.split(':');

	for (i = 0; i < listArr.length; ++i) 
	{
		// remove hash #
		var hash = jQuery.trim(listArr[i]);
		var panelid = 'vPanelID-' + hash;
      var headObj = jQuery('#'+panelid).siblings('.panel-heading');
      var headid = jQuery(headObj).attr('id');
      var isExpanded = 'false';
            
      isExpanded = jQuery('#' + panelid).attr("aria-expanded");

      if ( isExpanded != 'true' && jQuery( '#' + headid).length )
      {
         // Trigger the click of the matching heading anchor tag
         jQuery('#' + headid + ' a')[0].click();
      }	
   }
   
   return;        
}

****/



function getURLParam(k){
 	var p={};
 	location.search.replace(/[?&]+([^=&]+)=([^&]*)/gi,function(s,k,v){p[k]=v});
 	return k?p[k]:'';
}
